import string
import secrets

from mongo.get_conn import db_conn

class pool_data:
    """
    This class will allow us to
    interact with our data to interact
    just create a pool_data var
    """
    def __init__(self):
        #db_conn has all the the things
        #already created from here 
        #we can get self.db.real_db etc 
        self.db = db_conn()

    def record_exists(self, address):
        """
            This function will accept an address
            if it find that address in the database it will return True
            and set set the existing_record variable of the class to the 
            queried record
        """
        query = { "address" : f"{address}" }
        record = self.db.real_db.find_one(query)
        if record:
            self.existing_record = record
            return True
        else:
            return False


    def create_re_record(self, address, rooms, pool_link, like_out_of_five,
                         pool = "", requested_price="", user_price="", 
                         suburb="", actual_price=""):
        """
            create_re_record creates a whole new record
            takes the required 8 inputs
            1. address
            2. rooms
            3. pool
            4. realeastate link
            5. like out of 5
            6. requested_price - THe price the current owner wants if known
            7. user_price - what does the user think the price of hte house should be/what offer they've put down
            8. actual_price - after sold what price the house went for
            It will autogenerate the id string
            this string will be automatically selected
            on view in future
        """
        key = self.create_id()
        insert_record = {
                "_id" : f"{key}",
                "address": f"{address}",
                "rooms": f"{rooms}",
                "pool": f"{pool}",
                "pool_link": f"{pool_link}",
                "like_out_of_five": f"{like_out_of_five}",
                "requested_price": f"{requested_price}",
                "user_price": f"{user_price}",
                "actual_price": f"{actual_price}",
                "suburb" : f"{suburb}"
                }
        self.db.real_db.insert_one(insert_record)

    def update_re_record(self, id, field, value):
        """
            update_re_record
            will update the requested field to value for the
            selected field 
        """
        #TODO: do we need to make this take more than 1 id?

        query = { "_id": f"{id}"}
        update_val = {"$set": {f"{field}": f"{value}" }}
        self.db.real_db.update_one(query, update_val)

    def create_id(self):
        alphabet = string.ascii_letters + string.digits
        key = ''.join(secrets.choice(alphabet) for _ in range(24))
        return key

