import mongo.build_db as pool_database
import mongo.query_db as pool_database_query

from flask import Flask, render_template, request, jsonify, redirect

app = Flask(__name__)

@app.route("/", methods=["GET","POST"])
def index():
    if request.method == "POST":
        username = request.form["username"]
        password = request.form["password"]
        db = pool_database_query.pool_query()
        if db.user_check(username, password):
            return redirect("/updater")
        else:
            return render_template("index.html", try_again=True)
    else:
        return render_template("index.html", try_again=False)

@app.route("/updater", methods=["GET", "POST"])
def updater():
    query_db = pool_database_query.pool_query()
    query = query_db.get_top(10)

    if request.method == "POST":
        database = pool_database.pool_data()
        new_record = {
                "address": f'{request.form["address"]}',
                "rooms" : f'{request.form["rooms"]}',
                "real_estate_link": f'{request.form["real_estate_link"]}',
                "like_out_of_five": f'{request.form["like_out_of_five"]}',
                "pool": f'{request.form["pool"]}',
                "requested_price": f'{request.form["requested_price"]}',
                "user_price": f'{request.form["user_price"]}',
                "actual_price": f'{request.form["actual_price"]}',
                "suburb" : f'{request.form["suburb"]}'
            }
        if database.record_exists(new_record["address"]):
            for field in database.existing_record:
                for new_field in new_record:
                    if field == new_field:
                        if database.existing_record[field] != new_record[field]:
                            database.update_re_record(database.existing_record["_id"], field, new_record[field])
        else:
            database.create_re_record(new_record["address"], new_record["rooms"], new_record["real_estate_link"], 
                                      new_record["like_out_of_five"], new_record["pool"], new_record["requested_price"],
                                      new_record["user_price"], new_record["actual_price"], new_record["suburb"])


        return render_template("updater.html", list=query)
    else:
        return render_template("updater.html", list=query)

@app.route("/update_db", methods=["POST"])
def pool_data_update():
    database = pool_database.pool_data()
    new_record = request.json
    if database.record_exists(new_record["address"]):
        for field in database.existing_record:
            for new_field in new_record:
                if field == new_field:
                    if database.existing_record[field] != new_record[field]:
                        database.update_re_record(database.existing_record["_id"], field, new_record[field])
            else:
                database.create_re_record(new_record["address"], new_record["rooms"], new_record["real_estate_link"], 
                                      new_record["like_out_of_five"], new_record["pool"], new_record["requested_price"],
                                      new_record["user_price"], new_record["actual_price"])

@app.route("/pool_top/<int:return_number>")
def user_detail(id):
    query_db = pool_database_query.pool_query()
    query = query_db.get_top(return_number)
    return jsonify([row.to_json() for row in query])

if __name__ == '__main__':
    app.run(host='0.0.0.0', port=80)
